#!/usr/bin/perl
use Unicode::String qw(utf8);
<<DOC;
Format d\'entree : un texte tiquet et lemmatis par tree tagger et un format d'encodage
Format de Sortie : le mme texte au format xml (en utf-8)
DOC

# Usage
$ChaineUsage="Usage : tt2xml.pl <Fichier> <encodage>\n";
if (@ARGV!=2) {
 die $ChaineUsage;
}

&ouvre;
&entete;
&traitement;
&fin;
&ferme;
&entites_xml;

##############################################################################################
# Rcupration des arguments et ouverture des tampons
sub ouvre {
    $FichierEntree=$ARGV[0];
    $encodage=$ARGV[1];
    open(Entree,"<:encoding($encodage)",$FichierEntree);
    $FichierSortie=$FichierEntree . "\.xml";
    open(Sortie,">:encoding(utf-8)",$FichierSortie);
}

# Entte de document XML
sub entete {
    print Sortie "<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"no\"?>\n";
    print Sortie "<document>\n";
    print Sortie "<article>\n";
}

sub entites_xml {

    my ($forme) = @_;

    $forme =~ s/</&lt;/g;
    $forme =~ s/>/&gt;/g;
    $forme =~ s/&/&amp;/g;
    $forme =~ s/"/&quot;/g;
    $forme =~ s/'/&apos;/g;

    return $forme;

} # xml_entities

# Traitement
sub traitement {
    while ($Ligne = <Entree>) {
	   if (uc($encodage) ne "UTF-8") {utf8($Ligne);}
	   if ($Ligne!~/\\\:\\\\:\\/) {
	   # Remplacement des guillemets par <![CDATA["]]> (vite erreur d'interprtation XML)
	       $Ligne=~s/\"/<![CDATA[\"]]>/g;
           $Ligne=~ m/([^\t]*)\t([^\t]*)\t(.*)/;
           my $forme = $1;
           my $lemma = $3;
           my $forme = entites_xml($forme);
	       $Ligne=~s/([^\t]*)\t([^\t]*)\t(.*)/<element><data type=\"type\">$2<\/data><data type=\"lemma\">$lemma<\/data><data type=\"string\">$forme<\/data><\/element>/;
	       $Ligne=~s/<unknown>/unknown/g;
	       print Sortie $Ligne,"\n";
	   }
    }
}
# Fin de fichier
sub fin {
    print Sortie "</article>\n";
    print Sortie "</document>\n";
}

# Fermeture des tampons
sub ferme {
    close(Entree);
    close(Sortie);
}
